/**
 */
package tools.descartes.dni.dnimm3.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import tools.descartes.dni.dnimm3.DNIPackage;
import tools.descartes.dni.dnimm3.End;
import tools.descartes.dni.dnimm3.IType;
import tools.descartes.dni.dnimm3.Intermediate;
import tools.descartes.dni.dnimm3.NamedElement;
import tools.descartes.dni.dnimm3.NetworkInterface;
import tools.descartes.dni.dnimm3.Node;
import tools.descartes.dni.dnimm3.NodeType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Node</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NodeImpl#getName <em>Name</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NodeImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NodeImpl#getInterfaces <em>Interfaces</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NodeImpl#getSdntype <em>Sdntype</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NodeImpl#isIsPhysical <em>Is Physical</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NodeImpl#isIsPhysical_derived <em>Is Physical derived</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NodeImpl#getHosts <em>Hosts</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NodeImpl#getIsHostedOn <em>Is Hosted On</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NodeImpl#getEnd <em>End</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NodeImpl#getIntermediate <em>Intermediate</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NodeImpl#getEntityType <em>Entity Type</em>}</li>
 * </ul>
 *
 * @generated
 */
public class NodeImpl extends IdentifierImpl implements Node {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getInterfaces() <em>Interfaces</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaces()
	 * @generated
	 * @ordered
	 */
	protected EList<NetworkInterface> interfaces;

	/**
	 * The cached value of the '{@link #getSdntype() <em>Sdntype</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSdntype()
	 * @generated
	 * @ordered
	 */
	protected IType sdntype;

	/**
	 * The default value of the '{@link #isIsPhysical() <em>Is Physical</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsPhysical()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_PHYSICAL_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isIsPhysical() <em>Is Physical</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsPhysical()
	 * @generated
	 * @ordered
	 */
	protected boolean isPhysical = IS_PHYSICAL_EDEFAULT;

	/**
	 * This is true if the Is Physical attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean isPhysicalESet;

	/**
	 * The default value of the '{@link #isIsPhysical_derived() <em>Is Physical derived</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsPhysical_derived()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_PHYSICAL_DERIVED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #getHosts() <em>Hosts</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHosts()
	 * @generated
	 * @ordered
	 */
	protected EList<Node> hosts;

	/**
	 * The cached value of the '{@link #getIsHostedOn() <em>Is Hosted On</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIsHostedOn()
	 * @generated
	 * @ordered
	 */
	protected Node isHostedOn;

	/**
	 * The cached value of the '{@link #getEnd() <em>End</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEnd()
	 * @generated
	 * @ordered
	 */
	protected End end;

	/**
	 * The cached value of the '{@link #getIntermediate() <em>Intermediate</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIntermediate()
	 * @generated
	 * @ordered
	 */
	protected Intermediate intermediate;

	/**
	 * The cached value of the '{@link #getEntityType() <em>Entity Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEntityType()
	 * @generated
	 * @ordered
	 */
	protected NodeType entityType;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DNIPackage.Literals.NODE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<NetworkInterface> getInterfaces() {
		if (interfaces == null) {
			interfaces = new EObjectContainmentWithInverseEList<NetworkInterface>(NetworkInterface.class, this, DNIPackage.NODE__INTERFACES, DNIPackage.NETWORK_INTERFACE__NODE);
		}
		return interfaces;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IType getSdntype() {
		return sdntype;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSdntype(IType newSdntype, NotificationChain msgs) {
		IType oldSdntype = sdntype;
		sdntype = newSdntype;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__SDNTYPE, oldSdntype, newSdntype);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSdntype(IType newSdntype) {
		if (newSdntype != sdntype) {
			NotificationChain msgs = null;
			if (sdntype != null)
				msgs = ((InternalEObject)sdntype).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIPackage.NODE__SDNTYPE, null, msgs);
			if (newSdntype != null)
				msgs = ((InternalEObject)newSdntype).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DNIPackage.NODE__SDNTYPE, null, msgs);
			msgs = basicSetSdntype(newSdntype, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__SDNTYPE, newSdntype, newSdntype));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsPhysical() {
		return isPhysical;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsPhysical(boolean newIsPhysical) {
		boolean oldIsPhysical = isPhysical;
		isPhysical = newIsPhysical;
		boolean oldIsPhysicalESet = isPhysicalESet;
		isPhysicalESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__IS_PHYSICAL, oldIsPhysical, isPhysical, !oldIsPhysicalESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetIsPhysical() {
		boolean oldIsPhysical = isPhysical;
		boolean oldIsPhysicalESet = isPhysicalESet;
		isPhysical = IS_PHYSICAL_EDEFAULT;
		isPhysicalESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, DNIPackage.NODE__IS_PHYSICAL, oldIsPhysical, IS_PHYSICAL_EDEFAULT, oldIsPhysicalESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetIsPhysical() {
		return isPhysicalESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsPhysical_derived() {
		Node _isHostedOn = this.getIsHostedOn();
		boolean _tripleNotEquals = (_isHostedOn != null);
		if (_tripleNotEquals) {
			this.setIsPhysical(false);
		}
		Node _isHostedOn_1 = this.getIsHostedOn();
		boolean _tripleEquals = (_isHostedOn_1 == null);
		if (_tripleEquals) {
			this.setIsPhysical(true);
		}
		this.setIsPhysical(true);
		return this.isIsPhysical();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Node> getHosts() {
		if (hosts == null) {
			hosts = new EObjectWithInverseResolvingEList<Node>(Node.class, this, DNIPackage.NODE__HOSTS, DNIPackage.NODE__IS_HOSTED_ON);
		}
		return hosts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Node getIsHostedOn() {
		if (isHostedOn != null && isHostedOn.eIsProxy()) {
			InternalEObject oldIsHostedOn = (InternalEObject)isHostedOn;
			isHostedOn = (Node)eResolveProxy(oldIsHostedOn);
			if (isHostedOn != oldIsHostedOn) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, DNIPackage.NODE__IS_HOSTED_ON, oldIsHostedOn, isHostedOn));
			}
		}
		return isHostedOn;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Node basicGetIsHostedOn() {
		return isHostedOn;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetIsHostedOn(Node newIsHostedOn, NotificationChain msgs) {
		Node oldIsHostedOn = isHostedOn;
		isHostedOn = newIsHostedOn;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__IS_HOSTED_ON, oldIsHostedOn, newIsHostedOn);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsHostedOn(Node newIsHostedOn) {
		if (newIsHostedOn != isHostedOn) {
			NotificationChain msgs = null;
			if (isHostedOn != null)
				msgs = ((InternalEObject)isHostedOn).eInverseRemove(this, DNIPackage.NODE__HOSTS, Node.class, msgs);
			if (newIsHostedOn != null)
				msgs = ((InternalEObject)newIsHostedOn).eInverseAdd(this, DNIPackage.NODE__HOSTS, Node.class, msgs);
			msgs = basicSetIsHostedOn(newIsHostedOn, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__IS_HOSTED_ON, newIsHostedOn, newIsHostedOn));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public End getEnd() {
		return end;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEnd(End newEnd, NotificationChain msgs) {
		End oldEnd = end;
		end = newEnd;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__END, oldEnd, newEnd);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEnd(End newEnd) {
		if (newEnd != end) {
			NotificationChain msgs = null;
			if (end != null)
				msgs = ((InternalEObject)end).eInverseRemove(this, DNIPackage.END__NODE, End.class, msgs);
			if (newEnd != null)
				msgs = ((InternalEObject)newEnd).eInverseAdd(this, DNIPackage.END__NODE, End.class, msgs);
			msgs = basicSetEnd(newEnd, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__END, newEnd, newEnd));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Intermediate getIntermediate() {
		return intermediate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetIntermediate(Intermediate newIntermediate, NotificationChain msgs) {
		Intermediate oldIntermediate = intermediate;
		intermediate = newIntermediate;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__INTERMEDIATE, oldIntermediate, newIntermediate);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIntermediate(Intermediate newIntermediate) {
		if (newIntermediate != intermediate) {
			NotificationChain msgs = null;
			if (intermediate != null)
				msgs = ((InternalEObject)intermediate).eInverseRemove(this, DNIPackage.INTERMEDIATE__NODE, Intermediate.class, msgs);
			if (newIntermediate != null)
				msgs = ((InternalEObject)newIntermediate).eInverseAdd(this, DNIPackage.INTERMEDIATE__NODE, Intermediate.class, msgs);
			msgs = basicSetIntermediate(newIntermediate, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__INTERMEDIATE, newIntermediate, newIntermediate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NodeType getEntityType() {
		if (entityType != null && entityType.eIsProxy()) {
			InternalEObject oldEntityType = (InternalEObject)entityType;
			entityType = (NodeType)eResolveProxy(oldEntityType);
			if (entityType != oldEntityType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, DNIPackage.NODE__ENTITY_TYPE, oldEntityType, entityType));
			}
		}
		return entityType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NodeType basicGetEntityType() {
		return entityType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEntityType(NodeType newEntityType, NotificationChain msgs) {
		NodeType oldEntityType = entityType;
		entityType = newEntityType;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__ENTITY_TYPE, oldEntityType, newEntityType);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEntityType(NodeType newEntityType) {
		if (newEntityType != entityType) {
			NotificationChain msgs = null;
			if (entityType != null)
				msgs = ((InternalEObject)entityType).eInverseRemove(this, DNIPackage.NODE_TYPE__ENTITIES, NodeType.class, msgs);
			if (newEntityType != null)
				msgs = ((InternalEObject)newEntityType).eInverseAdd(this, DNIPackage.NODE_TYPE__ENTITIES, NodeType.class, msgs);
			msgs = basicSetEntityType(newEntityType, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NODE__ENTITY_TYPE, newEntityType, newEntityType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DNIPackage.NODE__INTERFACES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getInterfaces()).basicAdd(otherEnd, msgs);
			case DNIPackage.NODE__HOSTS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getHosts()).basicAdd(otherEnd, msgs);
			case DNIPackage.NODE__IS_HOSTED_ON:
				if (isHostedOn != null)
					msgs = ((InternalEObject)isHostedOn).eInverseRemove(this, DNIPackage.NODE__HOSTS, Node.class, msgs);
				return basicSetIsHostedOn((Node)otherEnd, msgs);
			case DNIPackage.NODE__END:
				if (end != null)
					msgs = ((InternalEObject)end).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIPackage.NODE__END, null, msgs);
				return basicSetEnd((End)otherEnd, msgs);
			case DNIPackage.NODE__INTERMEDIATE:
				if (intermediate != null)
					msgs = ((InternalEObject)intermediate).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIPackage.NODE__INTERMEDIATE, null, msgs);
				return basicSetIntermediate((Intermediate)otherEnd, msgs);
			case DNIPackage.NODE__ENTITY_TYPE:
				if (entityType != null)
					msgs = ((InternalEObject)entityType).eInverseRemove(this, DNIPackage.NODE_TYPE__ENTITIES, NodeType.class, msgs);
				return basicSetEntityType((NodeType)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DNIPackage.NODE__INTERFACES:
				return ((InternalEList<?>)getInterfaces()).basicRemove(otherEnd, msgs);
			case DNIPackage.NODE__SDNTYPE:
				return basicSetSdntype(null, msgs);
			case DNIPackage.NODE__HOSTS:
				return ((InternalEList<?>)getHosts()).basicRemove(otherEnd, msgs);
			case DNIPackage.NODE__IS_HOSTED_ON:
				return basicSetIsHostedOn(null, msgs);
			case DNIPackage.NODE__END:
				return basicSetEnd(null, msgs);
			case DNIPackage.NODE__INTERMEDIATE:
				return basicSetIntermediate(null, msgs);
			case DNIPackage.NODE__ENTITY_TYPE:
				return basicSetEntityType(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case DNIPackage.NODE__NAME:
				return getName();
			case DNIPackage.NODE__DESCRIPTION:
				return getDescription();
			case DNIPackage.NODE__INTERFACES:
				return getInterfaces();
			case DNIPackage.NODE__SDNTYPE:
				return getSdntype();
			case DNIPackage.NODE__IS_PHYSICAL:
				return isIsPhysical();
			case DNIPackage.NODE__IS_PHYSICAL_DERIVED:
				return isIsPhysical_derived();
			case DNIPackage.NODE__HOSTS:
				return getHosts();
			case DNIPackage.NODE__IS_HOSTED_ON:
				if (resolve) return getIsHostedOn();
				return basicGetIsHostedOn();
			case DNIPackage.NODE__END:
				return getEnd();
			case DNIPackage.NODE__INTERMEDIATE:
				return getIntermediate();
			case DNIPackage.NODE__ENTITY_TYPE:
				if (resolve) return getEntityType();
				return basicGetEntityType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case DNIPackage.NODE__NAME:
				setName((String)newValue);
				return;
			case DNIPackage.NODE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case DNIPackage.NODE__INTERFACES:
				getInterfaces().clear();
				getInterfaces().addAll((Collection<? extends NetworkInterface>)newValue);
				return;
			case DNIPackage.NODE__SDNTYPE:
				setSdntype((IType)newValue);
				return;
			case DNIPackage.NODE__IS_PHYSICAL:
				setIsPhysical((Boolean)newValue);
				return;
			case DNIPackage.NODE__HOSTS:
				getHosts().clear();
				getHosts().addAll((Collection<? extends Node>)newValue);
				return;
			case DNIPackage.NODE__IS_HOSTED_ON:
				setIsHostedOn((Node)newValue);
				return;
			case DNIPackage.NODE__END:
				setEnd((End)newValue);
				return;
			case DNIPackage.NODE__INTERMEDIATE:
				setIntermediate((Intermediate)newValue);
				return;
			case DNIPackage.NODE__ENTITY_TYPE:
				setEntityType((NodeType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case DNIPackage.NODE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case DNIPackage.NODE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case DNIPackage.NODE__INTERFACES:
				getInterfaces().clear();
				return;
			case DNIPackage.NODE__SDNTYPE:
				setSdntype((IType)null);
				return;
			case DNIPackage.NODE__IS_PHYSICAL:
				unsetIsPhysical();
				return;
			case DNIPackage.NODE__HOSTS:
				getHosts().clear();
				return;
			case DNIPackage.NODE__IS_HOSTED_ON:
				setIsHostedOn((Node)null);
				return;
			case DNIPackage.NODE__END:
				setEnd((End)null);
				return;
			case DNIPackage.NODE__INTERMEDIATE:
				setIntermediate((Intermediate)null);
				return;
			case DNIPackage.NODE__ENTITY_TYPE:
				setEntityType((NodeType)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case DNIPackage.NODE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case DNIPackage.NODE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case DNIPackage.NODE__INTERFACES:
				return interfaces != null && !interfaces.isEmpty();
			case DNIPackage.NODE__SDNTYPE:
				return sdntype != null;
			case DNIPackage.NODE__IS_PHYSICAL:
				return isSetIsPhysical();
			case DNIPackage.NODE__IS_PHYSICAL_DERIVED:
				return isIsPhysical_derived() != IS_PHYSICAL_DERIVED_EDEFAULT;
			case DNIPackage.NODE__HOSTS:
				return hosts != null && !hosts.isEmpty();
			case DNIPackage.NODE__IS_HOSTED_ON:
				return isHostedOn != null;
			case DNIPackage.NODE__END:
				return end != null;
			case DNIPackage.NODE__INTERMEDIATE:
				return intermediate != null;
			case DNIPackage.NODE__ENTITY_TYPE:
				return entityType != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == NamedElement.class) {
			switch (derivedFeatureID) {
				case DNIPackage.NODE__NAME: return DNIPackage.NAMED_ELEMENT__NAME;
				case DNIPackage.NODE__DESCRIPTION: return DNIPackage.NAMED_ELEMENT__DESCRIPTION;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == NamedElement.class) {
			switch (baseFeatureID) {
				case DNIPackage.NAMED_ELEMENT__NAME: return DNIPackage.NODE__NAME;
				case DNIPackage.NAMED_ELEMENT__DESCRIPTION: return DNIPackage.NODE__DESCRIPTION;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", description: ");
		result.append(description);
		result.append(", isPhysical: ");
		if (isPhysicalESet) result.append(isPhysical); else result.append("<unset>");
		result.append(')');
		return result.toString();
	}

} //NodeImpl
